Security Bugfix
http://cve.mitre.org/cgi-bin/cvename.cgi?name=CAN-2003-0577

--- common.c.orig	1999-06-15 18:24:19.000000000 -0300
+++ common.c	2003-07-11 14:28:13.000000000 -0300
@@ -123,7 +123,7 @@
 	return FALSE;
     if(!((head>>17)&3))
 	return FALSE;
-    if( ((head>>12)&0xf) == 0xf)
+    if(((head>>12)&0xf) == 0xf || ((head>>12)&0xf) == 0)
 	return FALSE;
     if( ((head>>10)&0x3) == 0x3 )
 	return FALSE;

Security Bugfix:
http://cve.mitre.org/cgi-bin/cvename.cgi?name=CAN-2003-0865

--- httpget.c.orig	Fri May 28 08:10:44 1999
+++ httpget.c	Tue Nov 11 13:50:17 2003
@@ -53,11 +53,11 @@ void readstring (char *string, int maxle
 #if 0
 	char *result;
 #endif
 	int pos = 0;
 
-	while(1) {
+	while(pos < maxlen) {
 		if( read(fileno(f),string+pos,1) == 1) {
 			pos++;
 			if(string[pos-1] == '\n') {
 				string[pos] = 0;
 				break;
@@ -66,10 +66,11 @@ void readstring (char *string, int maxle
 		else if(errno != EINTR) {
 			fprintf (stderr, "Error reading from socket or unexpected EOF.\n");
 			exit(1);
 		}
 	}
+	string[pos] = 0;
 #if 0
 	do {
 		result = fgets(string, maxlen, f);
 	} while (!result  && errno == EINTR);
 	if (!result) {
Index: audio_oss.c
--- audio_oss.c.orig	1998-01-31 15:14:08 +0100
+++ audio_oss.c	2004-09-17 15:23:49 +0200
@@ -30,6 +30,13 @@
 #include <linux/soundcard.h>
 #elif defined(__bsdi__)
 #include <sys/soundcard.h>
+#elif defined(__FreeBSD__)
+#include <osreldate.h>
+#if __FreeBSD_version >= 500000
+#include <sys/soundcard.h>
+#else
+#include <machine/soundcard.h>
+#endif
 #else
 #include <machine/soundcard.h>
 #endif

Security Bugfix
http://cve.mitre.org/cgi-bin/cvename.cgi?name=CAN-2004-0991

Index: common.c
--- common.c	2003/01/29 19:22:48	1.4
+++ common.c	2005/01/01 19:21:47	1.5
@@ -343,9 +343,12 @@
       fr->mpeg25 = 1;
     }
     
-    if (!param.tryresync || !oldhead) {
-          /* If "tryresync" is true, assume that certain
-             parameters do not change within the stream! */
+    if (!param.tryresync || !oldhead ||
+        (((oldhead>>19)&0x3) ^ ((newhead>>19)&0x3))) {
+          /* If "tryresync" is false, assume that certain
+             parameters do not change within the stream!
+	     Force an update if lsf or mpeg25 settings
+	     have changed. */
       fr->lay = 4-((newhead>>17)&3);
       if( ((newhead>>10)&0x3) == 0x3) {
         fprintf(stderr,"Stream error\n");
Index: layer2.c
--- layer2.c:1.2	Tue Sep  7 14:32:13 2004
+++ layer2.c	Sat Jan  1 20:21:47 2005
@@ -240,7 +240,7 @@
        { alloc_0, alloc_1, alloc_2, alloc_3 , alloc_4 };
   static int sblims[5] = { 27 , 30 , 8, 12 , 30 };
 
-  if(fr->lsf)
+  if(fr->sampling_frequency >= 3) /* Or equivalent: (fr->lsf == 1) */
     table = 4;
   else
     table = translate[fr->sampling_frequency][2-fr->stereo][fr->bitrate_index];

